<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Your Page Title</title>

    <script>
        function playjs() {
            
            // VARIABLES and ASSIGNMENTS:
            // Note each statement ends with a semicolon.
            // Use the var and let keywords to declare the variables (you must know the difference!)
            var age = 60;            // Declare a variable named age and assign it a number
            let name = 'mark';       // Declare a variable named name and assign it a string

            // Print the Values to the console log using the + string concatenation operator
            console.log("My name is " + name);
            console.log("My age is " + age);

           // MATH OPERATORS AND COMPARISON OPERATORS
           var number1 = 10;       // Declare a new variable to hold a number
            var number2 = 5;        // Declare a new variable to hold a number

            // Perform math operations and assign the results to variable
            var result = number1 + number2;                      // Addition
            console.log("Addition result is " + result);

            result = number1 - number2;                          // Subtraction
            console.log("Subtraction result is " + result);

            result = number1 * number2;                         // Multiplication
            console.log("Multiplication result is " + result);

            result = number1 / number2;                         // Division
            console.log("Division result is " + result);

            ++number1;                                          // Increment
            console.log("Increment result is " + number1);    

            --number1;                                          // Decrement  
            console.log("Decrement result is " + number1);    
            
            result = number1 ** number2;                        // Exponentiation
            console.log("Exponentiation result is " + result);
            // Perform some comparison operators

            console.log("Equality for 10 is " + (number1 == 10));
            console.log( "Equality for 2 numbers" + (number1 == number2));
            console.log("Equality for 2 numbers and type " + (number1 === number2));
            console.log("Inequality for 2 numbers" + (number1  != number2));
            console.log("Greater for 2 numbers" + (number1 > number2));
            console.log("Less than for 2 numbers" + (number1 < number2));

            // Array hold common data elements into a single variable. Each data element is separated by a comma, first element is at index.0
            let shapes1 = ['Triangle','Circle', 'Square'];                                  // Create an array using [a,b,c] syntax
            let shapes2 = new Array( 'Triangle', 'Circle', 'Square');                       // Create an array using the Array object
            console.log("First shape is" + shapes1[0]);                                     // Access first array element at index 0
            console.log("Last shape is"+ shapes1[shapes1.length-1]);                        // Access last array element at length -1
            // Common Array Methods 
            shapes1.sort();                                                                     // Sort the array
            console.log("First shape in sorted array is"+ shapes1[0]);                          // Access first array element at index 0
            console.log("Last shape in the sorted array is" + shapes1[shapes1.length-1]);       // Access last array element ar length - 1
            shapes1.reverse();                                                                 // Reverse the array
            console.log("First shape in reversed array is" + shapes1[0]);                       // Access first array element at index 0
            console.log("Last shape in reversed array is" + shapes1[shapes1.length-1]);         // Access last array element at length - 1
            shapes1.push('rectangle');                                                          // Access to the end of the array
            console.log("Last shape in array is" + shapes1[shapes1.length-1]);                  // Access last array element at length - 1
            shapes1.pop();                                                                      // Remove from the end of the array
            console.log("Last shape in spliced array is" + shapes1[shapes1.length-1]);          //access last array element at length - 1
            shapes1.splice(0, 0,'Oval');                                                        // Splice is great for ALL array operations 
            console.log("First shape in spliced array is" + shapes1[0]);                        // Access first array element aat index 0
           
           // Iteration (also see the for Each () however this requires the us of functions)
           
           for(let shape of shapes1)                                                            // Lope over the shapes1 array

            {
                console.log("The shape in" + shape);                                            // Display the current element in array 
            }

            // DATES AND FUNCTIONS
            // Some examples of creating dates and time
            let now = new Date()                                                                // Create a date variable for "now"
            let birthday = new Date(1960, 9, 17, 0, 0, 0);                                      // Create a date in the past 
            console.log("Currant date and time is" + now);                                      // Display the currant date and time
            console.log ("Past date and time is " + birthday);                                   // Display the past date and time
            console.log("Time difference is" + (now.getYear() - birthday.getYear()));           // Display difference in years

            // FUNCTIONS 
            // Some examples of calling functions
            reusableCode();                                                                     // Simple function
            result = add(15, 20);                                                               // Function with parameters and return value
            console.log(" Result is " + result);                                                // Display the function return value
            result = multiply(15, 20);                                                          // Function with parameters and return value
            console.log(" Result is " + result);                                                // Display the function return value
            shapes1.forEach(displayArray);                                                      // Iterate thru an array using a callback function

            /**
             * Functions are way to repeatable code by calling a set of code statements by a name.
             *  you can also pass variables to a function and return values from a functions.
             * */
             function reusableCode()
            {
                // Put any number of code statements that you want to execute every time this method is called.
                console.log( "called the reusableCode() function");
            }
            //Function to add 2 numbers specified by the caller and can be reused in your application 
            function add(num1, num2)
            {
                console.log("Adding numbers" + num1 + " and " + number2);
                return num1 + num2;
            }
            // Function to multiply 2 numbers specified by the caller and can be reused in your application
            function multiply(num1,num2)
            {
                console.log("Multiplying numbers" +num1+ "and" + num2);

            }
            // Reusable function to display a value from an array (can be used forEach () on an array
            function displayArray(value, index)
            {
                console.log("From displayArray() the array value in"() + value + " at" + index);
                
            }



        }
    </script>
</head>

<body onload="playjs()"> 
</body>

</html>